<?php
/*
	Copyright (c) 2009, Isa Goksu [ info@isagoksu.com ]

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Functions to generate FLV files from various sources.
	Most of the work here done by Chaosmaster. Thanks!

	Currently supported:

	56, Bebo, Bofunk, Clipfish, Crunchyroll, Dailymotion, eBaumsWorld,
	Google Video, Metacafe, MySpace, MyVideo, Supernovatube, Tudou,
	Veoh, Vimeo, Youku, Youtube
*/

// ------------------------ IMPLEMENTATION ---------------------------

/*
	$url = The FULL URL of the video
	$type = One of the following:
		FLV,
		FLV-HD,
		MP4,
		H264,
		DIVX
	
	Sample usage: <? print getLink($standardURL, "FLV"); ?>
*/

	function getLink($url, $type = "FLV") {
		$types = array("FLV", "FLV-HD", "MP4", "H264", "DIVX");
	
		if (!strstr($url, "http")) {
			return "<h3>You should put 'FULL URL' of the video here!</h3>";
			exit;
		}
	
		if (!array_search($type, $types)) {
			// default type
			$type = "FLV";
		}
	
		$url = urldecode($url);
		$result = array();
	
	    if (strstr($url,"youtube.com")) {
	        $result = download(getPatternFromUrl($url),false);
	    } else if (strstr($url,"tudou.com")) {
	        $result = downloadFromTudou(getPatternFromTudou($url));
	    } else if (strstr($url,"veoh.com")) {
	        $result = downloadFromVeoh(getPatternFromVeoh($url));
	    } else if (strstr($url,"56.com")) {
	        $result = downloadFrom56(getPatternFrom56($url));
	    } else if (strstr($url,"dailymotion.com")) {
	        $result = downloadFromDM(getPatternFromDM($url));
	    } else if (strstr($url,"myvideo.de")) {
	        $result = downloadFromMyVideo(getPatternFromMyVideo($url));
	    } else if (strstr($url,"ebaumsworld.com")) {
	        $result = downloadFromEBW(getPatternFromEBW($url));
	    } else if (strstr($url,"clipfish.de")) {
	        $result = downloadFromClipfish(getPatternFromClipfish($url));
	    } else if (strstr($url,"crunchyroll.com")) {
	        $result = downloadFromCR(getPatternFromCR($url));
	    } else if (strstr($url,"bofunk.com")) {
	        $result = downloadFromBofunk(getPatternFromBofunk($url));
	    } else if (strstr($url,"google.com")) {
	        $result = downloadFromGoogle(getPatternFromGoogle($url));
	    } else if (strstr($url,"metacafe.com")) {
	        $result = downloadFromMetacafe(getPatternFromMetacafe($url));
	    } else if (strstr($url,"bebo.com")) {
	        $result = downloadFromBebo(getPatternFromBebo($url));
	    } else if (strstr($url,"myspace.com")) {
	        $result = downloadFromMySpace(getPatternFromMySpace($url));
	    } else if (strstr($url,"vimeo.com")) {
	        $result = downloadFromVimeo(getPatternFromVimeo($url));
	    } else if (strstr($url,"supernovatube.com")) {
	        if (strstr($url,"divx")) {
	            $result = downloadFromSNT(getPatternFromSNT($url),true);
	        } else {
	            $result = downloadFromSNT(getPatternFromSNT($url),false);
	        };
	    } else if (strstr($url,"youku.com")) {
	        $result = downloadFromYouku(getPatternFromYouku($url));
	    }

		if (is_array($result)) {
			foreach ($result as $url) {
		        if (isset($url['flv']) && strtoupper($type) == "FLV") {
							return $url['flv'];
						}
		
				        if (isset($url['flv-hd']) && strtoupper($type) == "FLV-HD") {
							return $url['flv-hd'];
						}
		
				        if (isset($url['mp4']) && strtoupper($type) == "MP4") {
							return $url['mp4'];
						}
		
				        if (isset($url['h264']) && strtoupper($type) == "H264") {
							return $url['h264'];
						}
		
				        if (isset($url['divx']) && strtoupper($type) == "DIVX") {
							return $url['divx'];
						}
		    };
		}
    
	};

	function getPatternFromTudou($url) {
	    $url = $url.'/';
	    if (preg_match('#itemID=(.+?)/+#', $url, $matches)) {
	        return $matches[1];
	    } else if (preg_match('#iid=(.+?)/+#', $url, $matches)) {
	        return $matches[1];
	    }
	    else {
	        $pattern = '#[v|view]/(.+?)/+#';
	        preg_match($pattern, $url, $matches);
	        $url = "http://www.tudou.com/programs/view/".$matches[1];
	        $data = @file_get_contents($url);
	        preg_match('/[?]iid=(.+?)"/', $data, $match);
	        $id = $match[1];
	        return ($id);
	    };
	}

	function getPatternFromMyVideo($url) {
	    $url = $url.'/';
	    $pattern = '#watch/(.+?)/+#';
	    preg_match($pattern,$url,$matches);
	    return $matches[1];
	};

	function getPatternFromEBW($url) {
	    $url = $url.'/';
	    $pattern = '#watch/(.+?)/+#';
	    preg_match($pattern,$url,$matches);
	    return $matches[1];
	};

	function getPatternFromClipfish($url) {
	    $url = $url.'/';
	    $pattern = '#video/(.+?)/+#';
	    preg_match($pattern,$url,$matches);
	    return $matches[1];
	}

	function getPatternFromCR($url) {
	    $pattern = '#media-([0-9]+)#';
	    preg_match($pattern,$url,$matches);
	    return $matches[1];
	}

	function getPatternFromBofunk($url) {
	    $pattern = '#video/(.+)#';
	    preg_match($pattern,$url,$matches);
	    return $matches[1];
	}

	function getPatternFromGoogle($url) {
	    $pattern = '#docid=([0-9_-]+)#';
	    if (preg_match($pattern,$url,$matches)) return $matches[1];
	    else return false;
	}

	function getPatternFromMetacafe($url) {
	    $pattern = '#watch/(.+?)/#';
	    preg_match($pattern, $url, $matches);
	    return $matches[1];
	}

	function getPatternFromBebo($url) {
	    $pattern = '#FlashBoxId=([0-9]+)#';
	    preg_match($pattern, $url, $matches);
	    return $matches[1];
	}

	function getPatternFromMySpace($url) {
	    $url = $url.'/';
	    $pattern = '#VideoID=(.+?)/+#';
	    preg_match($pattern, $url, $matches);
	    return $matches[1];
	}

	function getPatternFromVimeo($url) {
	    $url= $url.'/';
	    $pattern= '#vimeo.com/(.+?)/+#';
	    preg_match($pattern, $url, $matches);
	    return $matches[1];
	}

	function getPatternFromSNT($url) {
	    $url = $url.'/';
	    $pattern = '#viewkey=(.+?)/+#';
	    preg_match($pattern, $url, $matches);
	    return ($matches[1]);
	}

	function getPatternFrom56($url) {
	    $pattern = '#.com/(.+?).html#';
	    preg_match($pattern, $url, $matches);
	    return ($matches[1]);
	}

	function getPatternfromDM($url) {
	    $url = $url.'/';
	    $pattern ='#video/(.+?)/+#';
	    preg_match($pattern, $url, $matches);
	    return ($matches[1]);
	};

	function getPatternFromMV($url) {
	    $url = $url.'/';
	    $pattern = '#v=(.+?)/+#';
	    preg_match($pattern, $url, $matches);
	    return ($matches[1]);
	}

	function getPatternFromVeoh($url) {
	    $url = $url.'/';
	    $pattern = '/.+watch.+(v\d+.*)/i';
	    preg_match($pattern, $url, $matches);
	    return str_replace("/", "", $matches[1]);
	}

	function getPatternFromYouku($url) {
	    $pattern = '#id[_|/](.+?)=#';
	    $pattern2 = '#(v_playlist/.*?)[.]html#';
	    if (preg_match($pattern, $url, $matches)) return ($matches[1]);
	    if (preg_match($pattern2, $url, $matches2)) return ($matches2[1]);
	}

	function getPatternFromUrl($url) {
	    $url = $url.'&';
	    $pattern = '/v=(.+?)&+/';
	    preg_match($pattern, $url, $matches);
	    return ($matches[1]);
	}

	function downloadFromMyVideo($video_id) {
	    global $output;
	    $url = "http://www.myvideo.de/watch/$video_id/";
	    $data = @file_get_contents($url);
	    $pattern = "#'SERVER','(.+?)'#";
	    if (!preg_match($pattern,$data,$matches)) $error=true;
	    $newpattern = '#http://'.$matches[1].'(.+?)thumbs/'.$video_id.'_1.jpg#';
	    if (!preg_match($newpattern,$data,$newmatches)) $error=true;
	    $url = "http://".$matches[1].$newmatches[1].$video_id.".flv";
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid MyVideo link.</font></br>\n";
	        return false;
	    };
	};

	function downloadFromEBW($video_id) {
	    global $output;
	    $url = "http://www.ebaumsworld.com/video/watch/$video_id/";
	    $data = @file_get_contents($url);
	    $pattern = '#&file=(.+?)&#';
	    if (!preg_match($pattern,urldecode($data),$matches)) $error=true;
	    $url = $matches[1];
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid eBaumsWorld link.</font></br>\n";
	        return false;
	    };
	};

	function downloadFromClipfish($video_id) {
	    global $output;
	    $url = "http://www.clipfish.de/video_n.php?vid=$video_id";
	    $data = @file_get_contents($url);
	    $pattern = '#&url=(.+?)&#';
	    if (!preg_match($pattern,urldecode($data),$matches)) $error=true;
	    $url = $matches[1];
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Clipfish link.</font></br>\n";
	        return false;
	    };
	};

	function downloadFromCR($video_id) {
	    global $output;
	    $url = "http://www.crunchyroll.com/media-$video_id/?hires=1";
	    $data = @file_get_contents($url);
	    $pattern = '#<file>(.+?)</file>#';
	    if (!preg_match($pattern,urldecode($data),$matches)) $error=true;
	    $url=preg_replace("#&amp;#","&",$matches[1]);
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Crunchyroll link.</font></br>\n";
	        return false;
	    };
	};

	function downloadFromBofunk($video_id) {
	    global $output;
	    $url = "http://www.bofunk.com/video/$video_id";
	    $data = @file_get_contents($url);
	    $pattern = '#<embed src="/w/(.+?)"#';
	    if (!preg_match($pattern,$data,$matches)) $error=true;;
	    $url="http://media.bofunk.com/media/flvs/".$matches[1].".flv";
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Bofunk link.</font></br>\n";
	        return false;
	    };
	};

	function downloadFromGoogle($video_id) {
	    global $output;
	    if ($video_id) return array(array("flv"=>"http://video.google.com/videofile/?docid=$video_id&itag=5","mp4"=>"http://video.google.com/videofile/?docid=$video_id&itag=7"));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Google Video link.</font></br>\n";
	        return false;
	    };
	}

	function downloadFromMetacafe($video_id) {
	    global $output;
	    if (preg_match('#^yt-(.+)#',$video_id,$matches)) {
	        return download($matches[1]);
	    } else {
	        $url = "http://www.metacafe.com/watch/$video_id";
	        $data = @file_get_contents($url);
	        $pattern = '#mediaURL":"(.+?)","gdaKey":"(.+?)"#';
	        if (!preg_match($pattern, $data, $matches)) $error=true;
	        $mediaURL=preg_replace('#\\\#','',$matches[1]);
	        $gdaKey=$matches[2];
	        $url=$mediaURL."?__gda__=".$gdaKey;
	        if (!$error) return array(array("flv"=>$url));
	        else {
	            $output.="<font color=\"#FF0000\">The link you provided is not a valid Metacafe link.</font></br>\n";
	            return false;
	        };
	    };
	}

	function downloadFromBebo ($video_id) {
	    global $output;
	    $url = "http://beboframe.com/FlashFrame.jsp?FlashBoxId=$video_id";
	    $data = @file_get_contents($url);
	    $pattern = '#file: "(.+?)"#';
	    if (!preg_match($pattern, $data, $matches)) $error=true;
	    $url = "http://".$matches[1]."_high.flv";
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Bebo link.</font></br>\n";
	        return false;
	    };
	}

	function downloadFromMySpace ($video_id) {
	    global $output;
	    $url = "http://mediaservices.myspace.com/services/rss.ashx?type=video&videoID=$video_id";
	    $data = @file_get_contents($url);
	    $pattern = '#<media:content url="(.+?)"#';
	    if (!preg_match($pattern, $data, $matches)) $error=true;
	    $url = $matches[1];
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid MySpace link.</font></br>\n";
	        return false;
	    };
	}

	function downloadFromVimeo ($video_id) {
	    global $output;
	    $url = "http://vimeo.com/moogaloop/load/clip:$video_id/local/";
	    $data = @file_get_contents($url);
	    $pattern = '#<isHD>(.+?)</isHD>.*?<request_signature>(.+?)</request_signature>.+?<request_signature_expires>(.+?)</request_signature_expires>#s';
	    if (!preg_match($pattern, $data, $matches)) $error=true;
	    $isHD=$matches[1];
	    $request_signature=$matches[2];
	    $request_signature_expires=$matches[3];
	    if ($isHD=="1") {
	        $q="hd";
	    } else {
	        $q="sd";
	    };
	    $url = "http://vimeo.com/moogaloop/play/clip:$video_id/$request_signature/$request_signature_expires/?q=$q";
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Vimeo link.</font></br>\n";
	        return false;
	    };
	}

	function downloadFromSNT ($video_id, $extra) {
	    global $output;
	    if ($extra) {
	        $data = POST(
	                    "divx.supernovatube.com",
	                    "http://divx.supernovatube.com/divxp.php?viewkey=$video_id",
	                    "http://divx.supernovatube.com/divx.php",
	                    "captcha=dontdoit&submit=Continue+to+Divx+Video"
	                );
	        $pattern = '#src" value="(.+?)"#';
	        if (!preg_match($pattern, $data, $matches)) $error=true;
	        $url = "http://divx.supernovatube.com/".$matches[1];
	        $return=array(array("divx"=>$url));
	    } else {
	        $url = "http://video.supernovatube.com/play.php?viewkey=$video_id";
	        $data = @file_get_contents($url);
	        $pattern = '#file","(.+?)"#';
	        if (!preg_match($pattern, $data, $matches)) {
	            $data = POST(
	                        "www.supernovatube.com",
	                        "http://www.supernovatube.com/play.php?viewkey=$video_id",
	                        "http://www.supernovatube.com/human.php?viewkey=$video_id",
	                        "captcha=dontdoit&submit=Continue+to+Video+-+I+am+Human%21"
	                    );
	            if (!preg_match($pattern, $data, $matches)) $error=true;
	        }
	        $url = $matches[1];
	        $return=array(array("flv"=>$url));
	    };

	    if (!$error) {
	        return $return;
	    } else {
	        $output.="<font color='#FF0000'>The link you provided is not a valid Supernovatube link.</font></br>n";
	        return false;
	    };
	}

	function downloadFrom56 ($video_id) {
	    global $output;
	    $url = "http://www.56.com/$video_id.html";
	    $data = @file_get_contents($url);
	    $pattern = '#&host=(.+?)&pURL=(.+?)&sURL=(.+?)&user=(.+?)&URLid=(.+?)&#';
	    if (preg_match($pattern, $data, $matches)) {
	        $host=$matches[1];
	        $pURL=$matches[2];
	        $sURL=$matches[3];
	        $user=$matches[4];
	        $URLid=$matches[5];
	    } else {
	        $pattern="#_oFlv_o = '(.+?)';#";
	        if (!preg_match($pattern, $data, $matches)) $error=true;
	        $url = decode56($matches[1]);
	        $url = str_replace("'", '"', $url);
	        $json = json_decode($url,true);
	        $host=$json["URL_host"];
	        $pURL=$json["URL_pURL"];
	        $sURL=$json["URL_sURL"];
	        $user=$json["user_id"];
	        $URLid=$json["URL_URLid"];
	    }
	    $url="http://ff.r.56.com/ff.$host/flvdownload/$pURL/$sURL/$user@56.com_56flv_$URLid.flv";
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid 56 link.</font></br>\n";
	        return false;
	    };
	}

	function downloadFromDM ($video_id) {
	    global $output;
	    $url = "http://www.dailymotion.com/video/$video_id";
	
		//Start the Curl session
		$session = curl_init($url);

		// Don't return HTTP headers. Do return the contents of the call
		curl_setopt($session, CURLOPT_HEADER, true);
		curl_setopt($session, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.9) Gecko/20071025 Firefox/2.0.0.9');
		curl_setopt($session, CURLOPT_FOLLOWLOCATION, false); 
		curl_setopt($session, CURLOPT_RETURNTRANSFER, true);

		// Make the call
		$response = curl_exec($session);
		$error = curl_error($session);
		$result = array( 'header' => '',
                         'body' => '',
                         'curl_error' => '',
                         'http_code' => '',
                         'last_url' => '');

		if (empty($error)) {
			$pattern = '#video", "(.+?)@@spark#';
			$matches = array();

			preg_match($pattern, urldecode($response), $matches);
			$urlInfo = parse_url(trim(array_pop($matches)));			

			$flvURL = "http://www.dailymotion.com".$urlInfo['path']."?".$urlInfo['query'];
		} 

		curl_close($session);
	
		return array(array("flv"=>$flvURL));
	}

	function downloadFromVeoh ($video_id) {
	    global $output;
	    $url = "http://www.veoh.com/rest/video/$video_id/details";
	    $data = @file_get_contents($url);
	    $pattern = '#fullPreviewHashPath="(.+?)"#';
	    if (!preg_match($pattern, $data, $matches)) $error=true;
	    $url = htmlspecialchars_decode($matches[1]);
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Veoh link.</font></br>\n";
	        return false;
	    };
	}

	function downloadFromYouku ($video_id, $recall=false) {
	    global $output;
	    if (strstr($video_id,"v_playlist")) {
	        $url="http://v.youku.com/$video_id.html";
	        $pattern = '#videoId2="(.+?)=#';
	    } else {
	        $url= "http://v.youku.com/v_show/id_$video_id=.html";
	        $pattern = "#videoId2= '(.+?)=#";
	    };
	    $data = @file_get_contents($url);
	    if (!preg_match($pattern, $data, $match)) $error=true;
	    $video_id=$match[1];
	    $pattern = "#'".$video_id."=*','(.+?)'#";
	    if ((!preg_match($pattern, $data, $match))&&(!$recall)) {
	        return downloadFromYouku($video_id, true);
	        exit;
	    };
	    $file_id=$match[1];
	    $url="http://f.youku.com/player/getFlvPath/sid/00_00/st/flv/fileid/".$match[1];
	    $url2= "http://v.youku.com/player/getPlayList/VideoIDS/$video_id/version/5/source/index";
	    $data = @file_get_contents($url2);
	    $parts = preg_match_all('#no":".+?","size#', $data, $test);
	    if (!preg_match('#key1":"(.+?)","key2":"(.+?)"#', $data, $keys)) $error=true;
	    $key=Youku_decrypt($keys[1],$keys[2]);
	    $urls=array();
	    if ($parts==0) {
	        array_push($urls, array("flv"=>"http://f.youku.com/player/getFlvPath/sid/00_00/st/flv/fileid/$file_id?K=$key"));
	    };
	    for ($i=0;$i<$parts;$i++) {
	        $no=strtoupper(dechex($i));
	        if (strlen($no)>1) {
	            $xyz= substr_replace($file_id,$no,8,2);
	        } else {
	            $xyz= substr_replace($file_id,$no,9,1);
	        };
	        array_push($urls, array("flv"=>"http://f.youku.com/player/getFlvPath/sid/00_00/st/flv/fileid/$xyz?K=$key"));
	    };
	    if (!$error) return $urls;
	    else {
	        $output.="<font color=\"#FF0000\">The link you provided is not a valid Youku link.</font></br>\n";
	        return false;
	    };
	}

	function download ($video_id) {
	    global $output;

	    $url = "http://www.youtube.com/watch?v=".$video_id;
	    $data = @file_get_contents($url);

	    preg_match('/"t": "(.*)",\ "hl"/', $data, $match);
		
		if (empty($match[1])) {
		    preg_match('/"t": "(.*)"\}/', $data, $match);
		}

	    $token = str_replace('"', '', $match[1]);
	    $url = "http://www.youtube.com/get_video?video_id=$video_id&t=$token";

	    return array(array("flv"=>$url));
	}

	function downloadFromTudou ($video_id) {
	    global $output;
	    $url = "http://v.tudou.com/cdn/v2.php?id=$video_id";
	    $data = @file_get_contents($url);
	    if (!preg_match('#<f w=".*?">(.*?)</f>#', $data, $match)) $error=true;
	    $url=$match[1];
	    if (!$error) return array(array("flv"=>$url));
	    else {
	        $output.="<font color='#FF0000'>The link you provided is not a valid Tudou link.</font></br>n";
	        return false;
	    };
	};

	function mv_decrypt($str_hex, $key1, $key2) {
	    $str_bin = "";
	    // 1. Convert hexadecimal string to binary string
	    for ($i = 0; $i < 128; $i++) {
	        $str_bin .= floor(hexdec($str_hex[floor($i/4)])/pow(2,(3-($i%4))))%2;
	    }
	    // 2. Generate switch and XOR keys
	    $key = Array();
	    for ($i = 0; $i < 384; $i++) {
	        $key1 = ($key1 * 11 + 77213) % 81371;
	        $key2 = ($key2 * 17 + 92717) % 192811;
	        $key[$i] = ($key1 + $key2) % 128;
	    }
	    // 3. Switch bits positions
	    for ($i = 256; $i >= 0; $i--) {
	        $temp = $str_bin[$key[$i]];
	        $str_bin[$key[$i]] = $str_bin[$i%128];
	        $str_bin[$i%128] = $temp;
	    }
	    // 4. XOR entire binary string
	    for ($i = 0; $i < 128; $i++) {
	        $str_bin[$i] = $str_bin[$i] ^ $key[$i+256] & 1;
	    }
	    // 5. Convert binary string back to hexadecimal
	    $str_hex = "";
	    for ($i = 0; $i < 32; $i++) {
	        $str_hex .= dechex(bindec(substr($str_bin, $i*4, 4)));
	    }
	    // 6. Return counted string
	    return $str_hex;
	}

	$de = 0;

	function decode56($str) {
	    global $de;
	    $c1 = "";
	    $c2 = "";
	    $c3 = "";
	    $c4 = "";
	    $c5 = array(-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,62,-1,-1,-1,63,52,53,54,55,56,57,58,59,60,61,-1,-1,-1,-1,-1,-1,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1,-1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40, 41,42,43,44,45,46,47,48,49,50,51,-1,-1,-1,-1,-1);
	    $c6 = charCodeAt($str, 0);
	    $c7 = "";
	    $i = "";
	    $len = "";
	    $out = "";
	    if (!$de) {
	        $de = 1;
	        $c7 = decode56($str);
	        $str = substr($c7, $c6);
	    }
	    $len = strlen($str);
	    $i = 1;
	    $out = "";
	    while ($i < $len) {
	        do {
	            $c1 = $c5[charCodeAt($str, $i++) & 0xff];
	        } while ($i < $len && $c1 == -1);
	        if ($c1 == -1) break;
	        do {
	            $c2 = $c5[charCodeAt($str, $i++) & 0xff];
	        } while ($i < $len && $c2 == -1);
	        if ($c2 == -1) break;
	        $out .= chr(($c1 << 2) | (($c2 & 0x30) >> 4));
	        do {
	            $c3 = charCodeAt($str, $i++) & 0xff;
	            if ($c3 == 61) return $out;
	            $c3 = $c5[$c3];
	        } while ($i < $len && $c3 == -1);
	        if ($c3 == -1) break;
	        $out .= chr((($c2 & 0XF) << 4) | (($c3 & 0x3C) >> 2));
	        do {
	            $c4 = charCodeAt($str, $i++) & 0xff;
	            if ($c4 == 61) return $out;
	            $c4 = $c5[$c4];
	        } while ($i < $len && $c4 == -1);
	        if ($c4 == -1) break;
	        $out .= chr((($c3 & 0x03) << 6) | $c4);
	    }
	    return $out;
	}

	function charCodeAt($str, $i) {
	    return ord(substr($str, $i, 1));
	}

	function Youku_decrypt($key1, $key2) {
	    $key1 = hexdec($key1) ^ hexdec(A55AA5A5);
	    return $key2.dechex($key1);
	}

	function POST($host, $path, $referer, $data_to_send) {
	    $fp = fsockopen($host, 80);
	    fputs($fp, "POST $path HTTP/1.1\r\n");
	    fputs($fp, "Host: $host\r\n");
	    fputs($fp, "Referer: $referer\r\n");
	    fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
	    fputs($fp, "Content-length: ". strlen($data_to_send) ."\r\n");
	    fputs($fp, "Connection: close\r\n\r\n");
	    fputs($fp, $data_to_send);
	    while (!feof($fp)) {
	        $res .= fgets($fp,128);
	    }
	    fclose($fp);
	    return $res;
	}

	function GET($host, $path, $referer="") {
	    $fp = fsockopen($host, 80);
	    fputs($fp, "GET $path HTTP/1.1\r\n");
	    fputs($fp, "Host: $host\r\n");
	    fputs($fp, "User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; de; rv:1.9.0.1) Gecko/2008070208 Firefox/3.0.1\r\n");
	    fputs($fp, "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n");
	    fputs($fp, "Accept-Language: de-de,de;q=0.8,en-us;q=0.6,en;q=0.4,es;q=0.2\r\n");
	    fputs($fp, "Accept-Encoding: none\r\n");
	    fputs($fp, "Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n");
	    fputs($fp, "Keep-Alive: 300\r\n");
	    fputs($fp, "Referer: $referer\r\n");
	    fputs($fp, "Connection: keep-alive\r\n\r\n");
	    while (!feof($fp)) {
	        $res .= fgets($fp,128);
	    }
	    fclose($fp);
	    preg_match("#^(.+)\r\n\r\n(.+)$#s",$res,$matches);
	    return $matches[2];
	}

	function urlexists($url) {
	    $url.='/';
	    $pattern='#http://(.+?)/+#';
	    preg_match($pattern,$url,$matches);
	    $host=$matches[1];
	    if ($fp = fsockopen($host, 80)) {
	        fputs($fp, "GET $url HTTP/1.1\r\n");
	        fputs($fp, "Host: $host\r\n");
	        fputs($fp, "Connection: close\r\n\r\n");
	        $pattern = '#HTTP/... ([0-9]+?) #';
	        $pattern2 = '#Location: (.+?)$#';
	        $pattern3 = '#Content-Type:#';
	        while ((!preg_match($pattern3,$res, $matches2)) && (!feof($fp)) && (!$stop)) {
	            $res .= fgets($fp,128);
	            if (preg_match($pattern2,$res,$matches)) {
	                $stop=true;
	                return urlexists($matches[1]);
	                exit();
	            };
	            preg_match($pattern,$res,$matches);
	        }
	        fclose($fp);
	        $http_response=$matches[1];
	        if ($http_response=="404") return false;
	        else return true;
	    } else return false;
	}

	function getYouTubePreviewImage($url) {
		$id = getPatternFromUrl($url);
	
		return "http://i.ytimg.com/vi/$id/0.jpg";
	}

	function getVimeoPreviewImage($url) {
		$id = getPatternFromVimeo($url);
		$url = "http://vimeo.com/moogaloop/load/clip:$id/local/";
	   $data = @file_get_contents($url);
	   $pattern = "/<thumbnail>(.*)<\/thumbnail>/i";
		preg_match($pattern, $data, $matches);
	
		return $matches[1];
	}

	function getVeohPreviewImage($url) {
		$id = getPatternFromVeoh($url);
		$url = "http://www.veoh.com/rest/video/$id/details";
	   $data = @file_get_contents($url);
	   $pattern = "/highResImage=\"(media\-.+)\"/i";
		preg_match($pattern, $data, $matches);

		if (!empty($matches[1])) {
			return "http://ll-images.veoh.com/media/w640/".$matches[1];
		} else {
		   $pattern = "/fullHighResImagePath=\"(.+)\"/i";
			preg_match($pattern, $data, $matches);
		
			return $match[1];
		}
	}
?>